/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Jugador (resource_id,x,y,escala,face_x,face_y,face_w,face_h,name,id,body,body_w,body_h){ 
	//Propiedades
	
	//id
	this.id=id;
	
	//Nombre
	this.nombre=name;
	
	//Cuerpo
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = URL_IMAGENES+"bodys/"+body+".png";
	this.cuerpo_width=body_w*ESCALA_GENERAL;
	this.cuerpo_height=body_h*ESCALA_GENERAL;
	this.x=x;
	this.y=y;
	this.xref=Math.round(this.cuerpo_width/2);
	this.yref=Math.round(this.cuerpo_height);
	
	//Cara
	this.cara_img=new Image();
	this.cara_img.src=URL_IMAGENES+"faces/"+resource_id+".jpg";
	this.cara_xref=face_x*escala; //x respecto al cuerpo
	this.cara_yref=face_y*escala; //y respecto al cuerpo
	this.cara_w=face_w*escala;
	this.cara_h=face_h*escala;
	
	//Metodos
	this.getX=function(){return this.x+this.xref;}
	this.getY=function(){return this.y+this.yref;}
	this.getXCara=function(){return this.x+this.cara_xref;}
	this.getYCara=function(){return this.y+this.cara_yref;}
	
	//Es usuario
	this.isUser=0;
	if(name=="{{myappearance}}")
		this.isUser=1;
}

function Miembros (){

	this.apariencias=new Array({{ datos_miembros|length }});
	var i=0;
	{% for d in datos_miembros %}
		var apariencia=new Array(11);
		apariencia[0]={{ d.resource_id }}; //resource_id
		apariencia[1]={{ d.escala }}; //escala
		apariencia[2]={{ d.face_x }}; //face_x
		apariencia[3]={{ d.face_y }}; //face_y
		apariencia[4]={{ d.face_w }}; //face_w
		apariencia[5]={{ d.face_h }}; //face_h
		apariencia[6]="{{ d.name }}"; //Nombre
		apariencia[7]={{ d.id }}; //id
		apariencia[8]="{{ d.body_name }}"; //cuerpo
		apariencia[9]={{ d.body_w }}/2; //cuerpo anchura
		apariencia[10]={{ d.body_h }}/2; //cuerpo altura
		
		this.apariencias[i]=apariencia;
		i++;
	{% endfor %}
	
	this.obtener_miembro=function(id){
		var i;
		for(i=0;i<this.apariencias.length;i++)
			if(this.apariencias[i][7]==id)
				return this.apariencias[i];
		var error=new Array(6);
		for(i=0;i<7;i++)
			error[i]=0;
		error[8]="cuerpo_chico_00";
		return error;
	}
}

function Bandas (){

	var n_bandas={{ datos_bandas|length }};
	this.bandas=new Array(n_bandas);

	var datos_bandas=new Array();
	
	{% for datos_banda in datos_bandas %}
		var datos_banda=new Array();
		{% for dato in datos_banda %}
			datos_banda[datos_banda.length]="{{ dato }}";
		{% endfor %}
		datos_bandas[datos_bandas.length]=datos_banda;
	{% endfor %}
	
	//Repartimos los elementos por la pantalla
	var coordenadas=repartir_elementos(ANCHURA_VENTANA/2,ALTURA_VENTANA/2,n_bandas,3,150,150,MARGEN_ENTRE_BANDAS);

	var i;
	for(i=0;i<n_bandas;i++){
		this.bandas[i]=new Banda(datos_bandas[i],coordenadas[i][0],coordenadas[i][1]);
	}
	
	this.banda_destacada=-1;
	
	//Opciones para cada banda
	this.opciones=new Array(2);
	var coordenadas=repartir_elementos(CENTRAR_BANDA_X+175,CENTRAR_BANDA_Y+75,this.opciones.length,1,50,50,20);
	this.opciones[0]=new Boton("boton_nuevomiembro",coordenadas[0][0],coordenadas[0][1],50,50);
	this.opciones[1]=new Boton("boton_volver",coordenadas[1][0],coordenadas[1][1],50,50);
	this.opcion_destacada=-1;
	
	this.imagen=new Image();
	this.imagen.src=URL_IMAGENES+"scenarios/fondo_bandas.jpg";
	
	this.marco_img=new Image();
	this.marco_img.src=URL_IMAGENES+"interface/vinyl_frame.jpg";
}

function Banda (datos,x,y){
	this.id=datos[0];
	this.name=new Texto(ascii_a_cadena(datos[1]),x+73,y+50,100,20,AL_CEN);
	this.ascii_name=new Texto(datos[1],x+73,y+50,100,20,AL_CEN);
	var coordenadas_members=repartir_elementos(ANCHURA_VENTANA/2,3*ALTURA_VENTANA/4,datos.length-2,10,100,200,50);
	this.members=new Array(datos.length-2);
	this.opciones=new Array(datos.length-2);
	this.opcion_destacada=-1;
	for(i=2;i<datos.length;i++){
		var apariencia = miembros.obtener_miembro(datos[i]);
		this.members[i-2]=new Jugador(apariencia[0],coordenadas_members[i-2][0],coordenadas_members[i-2][1],apariencia[1],apariencia[2],
										apariencia[3],apariencia[4],apariencia[5],apariencia[6],apariencia[7],apariencia[8],apariencia[9],
										apariencia[10]);
		this.opciones[i-2]=new Boton("boton_cerrar",this.members[i-2].x+100,this.members[i-2].y+100,30,30);
	}
	this.x_orig=x;
	this.y_orig=y;
	this.x=x;
	this.y=y;
	this.escala=0;
	this.velocidad_crecer=0.05;
	this.velocidad_x=0.05;
	this.velocidad_y=0.05;
	this.alpha=1.0;
	
	this.lanzar=0;
	this.crecer=1;
	this.show_text=0
	this.centrar=0;
	this.desvanecer=0;
	this.descentrar=0;
}

function Dialogo(x,y,w,h,tag){
	
	this.tag=tag;
	if(tag!=-1){
		this.x=x;
		this.y=y;
		this.w=w;
		this.h=h;
		this.alpha=0.0;
		this.opcion_apuntada=-1;
		this.opcion_w=100;
		this.opcion_h=50;
		this.coordenadas_opciones=repartir_elementos(ANCHURA_VENTANA/2,y+h-h/3,2,2,this.opcion_w,this.opcion_h,50);
		
		this.destacar_opciones=function(x,y){
			this.opcion_apuntada=-1;
			var i;
			for(i=0;i<this.coordenadas_opciones.length && this.opcion_apuntada==-1;i++){
				var x1=this.coordenadas_opciones[i][0];
				var y1=this.coordenadas_opciones[i][1];
				var x2=x1+this.opcion_w;
				var y2=y1+this.opcion_h;

				if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
					this.opcion_apuntada=i;
			}			
		}
	}	
}