/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Jugador (id,x,y,escala,face_x,face_y,face_w,face_h,body_name,body_w,body_h){ 
	//Propiedades
	
	//Nombre
	this.nombre=name;
	
	var escala_escenario=0.5; //borrar
	
	//Cuerpo
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = URL_IMAGENES+"bodys/"+body_name+".png";
	this.cuerpo_width=myround((body_w/2)*ESCALA_GENERAL*escala_escenario);
	this.cuerpo_height=myround((body_h/2)*ESCALA_GENERAL*escala_escenario);
	this.x=myround(x);
	this.y=myround(y);
	this.xref=myround(this.cuerpo_width/2);
	this.yref=myround(this.cuerpo_height);
	
	//Cara
	this.cara_img=new Image();
	this.cara_img.src=URL_IMAGENES+"faces/"+id+".jpg";
	this.cara_xref=face_x*escala*escala_escenario; //x respecto al cuerpo
	this.cara_yref=face_y*escala*escala_escenario; //y respecto al cuerpo
	this.cara_w=face_w*escala*escala_escenario;
	this.cara_h=face_h*escala*escala_escenario;
	
	//Metodos
	this.getX=function(){return this.x+this.xref;}
	this.getY=function(){return this.y+this.yref;}
	this.getXCara=function(){return this.x+this.cara_xref;}
	this.getYCara=function(){return this.y+this.cara_yref;}
}

function Banda (){
	this.name="{{ banda }}";
	
	var altura_banda_escenario=290;//borrar
	var margen_izq_banda_escenario=100; //borrar
	
	this.miembros=new Array({{ members_appearances|length }});
	var i=0;
	var x=margen_izq_banda_escenario+myround(Math.random()*400);
	{% for ma in members_appearances %}
		this.miembros[i]=new Jugador({{ ma.resource_id }},x,altura_banda_escenario,{{ ma.escala }},{{ ma.face_x }},{{ ma.face_y }},{{ ma.face_w }},{{ ma.face_h }},"{{ ma.body_name }}",{{ ma.body_w }},{{ ma.body_h }});
		i++;
		x+=50+Math.floor(Math.random()*250);
	{% endfor %}
	
	this.instrumentos=new Array({{ instruments|length }});
	i=0;	
	{% for i in instruments %}
		this.instrumentos[i]=new Objeto("{{ i.brand }}_{{ i.name }}",this.miembros[i].x+this.miembros[i].cuerpo_width,this.miembros[i].y+this.miembros[i].cuerpo_height/4,200,3*(this.miembros[i].cuerpo_height/4));
		i++;
	{% endfor %}
}

function Publico (){
	var altura_publico_escenario=350; //borrar
	var margen_izq_publico_escenario=75; //borrar
	
	this.publico=new Array({{ public_appearances|length }});
	var i=0;
	var y=altura_publico_escenario+myround(Math.random()*10);
	{% for pa in public_appearances %}
		var x=margen_izq_publico_escenario+myround(Math.random()*600);
		y+=Math.floor(Math.random()*10);
		this.publico[i]=new Jugador({{ pa.resource_id }},x,y,{{ pa.escala }},{{ pa.face_x }},{{ pa.face_y }},{{ pa.face_w }},{{ pa.face_h }},"{{ pa.body_name }}",{{ pa.body_w }},{{ pa.body_h }});
		i++;
	{% endfor %}
}

function Escenario(){	
	//Cargamos la imagen de fondo
	this.fondo=new Image();
	this.fondo.src=URL_IMAGENES+"scenarios/fondo_escenario_prueba2.jpg";
}

function Objeto(nombre,x,y,w,h){
	
	this.escala_escenario=0.5; //borrar
	
	//Propiedades
	this.id=nombre;
	this.objeto_img=new Image();
	this.objeto_img.src=URL_IMAGENES+"objects/"+nombre+".png";
	this.x=myround(x);
	this.y=myround(y);
	this.width=0;
	this.height=myround(h);
	
	this.actualizar_dimensiones=function(){
		var proporcion=this.objeto_img.width/this.objeto_img.height;
		this.width=this.height*proporcion;
	}
}