/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_fondo(){
	contexto.fillStyle="4444FF";
	contexto.beginPath();
	contexto.rect(0,0,ANCHURA_VENTANA,ALTURA_VENTANA);
	contexto.closePath();
	contexto.fill();
}

function dibujar_jugador(){
	//Dibujamos al jugador
	contexto.drawImage(jugador.cara_img, jugador.img_x1, jugador.img_y1, 
						jugador.img_x2-jugador.img_x1, jugador.img_y2-jugador.img_y1,
						jugador.lienzo_x, jugador.lienzo_y,							
						(jugador.cara_w*jugador.escala)-jugador.trozo_izquierda-jugador.trozo_derecha, 
						(jugador.cara_h*jugador.escala)-jugador.trozo_arriba-jugador.trozo_abajo);
	
	contexto.drawImage(jugador.cuerpo_img[jugador.cuerpo_activo],
						jugador.cuerpo_x[jugador.cuerpo_activo], jugador.cuerpo_y[jugador.cuerpo_activo], 
						jugador.cuerpo_w[jugador.cuerpo_activo], jugador.cuerpo_h[jugador.cuerpo_activo]);
	
	contexto.strokeStyle="00FF00";
	contexto.beginPath();
	contexto.rect(jugador.cara_x,jugador.cara_y,jugador.cara_w*jugador.escala,jugador.cara_h*jugador.escala);
	contexto.closePath();
	contexto.stroke();
	
	if(jugador.esquina_x!=-1 && jugador.esquina_y!=-1){
		contexto.beginPath();
		contexto.rect(jugador.esquina_x-jugador.tam_esquina,jugador.esquina_y-jugador.tam_esquina,jugador.tam_esquina*2,jugador.tam_esquina*2);
		contexto.closePath();
		contexto.stroke();
	}
}

function dibujar_botones(){
	if(boton_ok.apuntado)
		contexto.drawImage(boton_ok.over_image, boton_ok.x, boton_ok.y, boton_ok.w, boton_ok.h);
	else
		contexto.drawImage(boton_ok.image, boton_ok.x, boton_ok.y, boton_ok.w, boton_ok.h);
	
	if(boton_izq.apuntado)
		contexto.drawImage(boton_izq.over_image, boton_izq.x, boton_izq.y, boton_izq.w, boton_izq.h);
	else
		contexto.drawImage(boton_izq.image, boton_izq.x, boton_izq.y, boton_izq.w, boton_izq.h);
	
	if(boton_dch.apuntado)
		contexto.drawImage(boton_dch.over_image, boton_dch.x, boton_dch.y, boton_dch.w, boton_dch.h);
	else
		contexto.drawImage(boton_dch.image, boton_dch.x, boton_dch.y, boton_dch.w, boton_dch.h);
}

function dibujar_depurar(){
	
	contexto.save();
	//Showing the grid
	contexto.strokeStyle = '#F0F'; // Color
	for(i=0;i<GRID_ROWS;i++){
		contexto.beginPath();
		contexto.moveTo(0,TAM_GRID_SQUARE_Y*i);
		contexto.lineTo(ANCHURA_VENTANA,TAM_GRID_SQUARE_Y*i);
		contexto.closePath();
		contexto.stroke();
	}
	
	for(i=0;i<GRID_COLUMNS;i++){
		contexto.beginPath();
		contexto.moveTo(TAM_GRID_SQUARE_X*i,0);
		contexto.lineTo(TAM_GRID_SQUARE_X*i,ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	contexto.restore();
}

function roundRect(x, y, width, height, radius) {
    contexto.beginPath();
    contexto.moveTo(x + radius, y);
    contexto.lineTo(x + width - radius, y);
    contexto.arc(x+width-radius, y+radius, radius, -Math.PI/2, Math.PI/2, false);
    contexto.lineTo(x + radius, y + height);
    contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    contexto.closePath();
    contexto.fill();
}

function progressLayerRect(x, y, width, height, radius) {
    contexto.save();
    // Define the shadows
    contexto.shadowOffsetX = 2;
    contexto.shadowOffsetY = 2;
    contexto.shadowBlur = 5;
    contexto.shadowColor = '#666';
 
     // first grey layer
    contexto.fillStyle = 'rgba(189,189,189,1)';
    roundRect(x, y, width, height, radius);
 
    // second layer with gradient
    // remove the shadow
    contexto.shadowColor = 'rgba(0,0,0,0)';
    var lingrad = contexto.createLinearGradient(0,y+height,0,0);
    lingrad.addColorStop(0, 'rgba(255,255,255, 0.1)');
    lingrad.addColorStop(0.4, 'rgba(255,255,255, 0.7)');
    lingrad.addColorStop(1, 'rgba(255,255,255,0.4)');
    contexto.fillStyle = lingrad;
    roundRect(x, y, width, height, radius);
 
    contexto.restore();
}

function progressBarRect(x, y, width, height, radius, max) {
    contexto.save();
	
	// Blue gradient for progress bar
	var progress_lingrad = contexto.createLinearGradient(0,250,0,0);
	progress_lingrad.addColorStop(0, '#4DF3A4');
	progress_lingrad.addColorStop(0.4, '#ADFFD9');
	progress_lingrad.addColorStop(1, '#9EFFD1');
	
    // deplacement for chord drawing
    var offset = 0;
    contexto.beginPath();
    if (width<radius) {
        offset = radius - Math.sqrt(Math.pow(radius,2)-Math.pow((radius-width),2));
        // Left angle
        var left_angle = Math.acos((radius - width) / radius);
        contexto.moveTo(x + width, y+offset);
        contexto.lineTo(x + width, y+height-offset);
        contexto.arc(x + radius, y + radius, radius, Math.PI - left_angle, Math.PI + left_angle, false);
    }
    else if (width+radius>max) {
        offset = radius - Math.sqrt(Math.pow(radius,2)-Math.pow((radius - (max-width)),2));
        // Right angle
        var right_angle = Math.acos((radius - (max-width)) / radius);
        contexto.moveTo(x + radius, y);
        contexto.lineTo(x + width, y);
        contexto.arc(x+max-radius, y + radius, radius, -Math.PI/2, -right_angle, false);
        contexto.lineTo(x + width, y+height-offset);
        contexto.arc(x+max-radius, y + radius, radius, right_angle, Math.PI/2, false);
        contexto.lineTo(x + radius, y + height);
        contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    }
    else {
        contexto.moveTo(x + radius, y);
        contexto.lineTo(x + width, y);
        contexto.lineTo(x + width, y + height);
        contexto.lineTo(x + radius, y + height);
        contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    }
    contexto.closePath();
    contexto.fillStyle = progress_lingrad;
    contexto.fill();
	
	// texto
    var text = Math.floor(width/max*100)+"%";
    var text_width = contexto.measureText(text).width;
    var text_x = x+width-text_width-radius/2;
    if (width<=radius+text_width) {
        text_x = x+radius/2;
    }
		
    contexto.fillStyle = "#FFFFFF"; // Color del texto
    contexto.font = "bold 20px Comic Sans"; // Tamano y estilo de la fuente
    contexto.fillText(text, text_x, y+22);
	
    contexto.restore();
}

function draw_progressbar(){
	if(progreso>100) progreso=100;	
	contexto.save();
	var gradiente = contexto.createRadialGradient(ANCHURA_VENTANA/2, ALTURA_VENTANA/2, 20, ANCHURA_VENTANA/2, ALTURA_VENTANA/2, 200);
    gradiente.addColorStop(0, "#8ED6FF");
    gradiente.addColorStop(1, "#004CB3");
    contexto.fillStyle = gradiente;
    contexto.fill();
	contexto.beginPath();
	contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
	contexto.closePath();
	contexto.fill();
	contexto.restore();
	var initial_x=(ANCHURA_VENTANA/2)-150;
	var initial_y=(ALTURA_VENTANA/2)-25;
	progressLayerRect(initial_x, initial_y, 300, 50, 25);
	progressBarRect(initial_x, initial_y, (3*progreso), 50, 25, 300);
}

function draw_fadein(){
	if(fadein_alpha>0.0){
		contexto.save();
		contexto.globalAlpha=fadein_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadein_alpha-=FADE_SPEED;
		contexto.restore();
		if(fadein_alpha<=0.0){
			//Inicializamos las bandas
			desbloquear();
		}
	}
}

function draw_fadeout(){
	if(fadeout_alpha<1.0){
		contexto.save();
		contexto.globalAlpha=fadeout_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadeout_alpha+=FADE_SPEED;
		contexto.restore();
		if(fadeout_alpha>=1.0){
			contexto.globalAlpha=0.0;
			redireccionar(url_redireccionar);
		}
	}
}