/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");
	
	depurar=0;

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	down=0;
	down_x=-1;
	down_y=-1;
	
	//Inicializamos el grid
	grid=new Grid();
	
	//Inicializamos el jugador
	jugador=new Jugador();
	
	//Inicializamos el boton ok
	boton_ok=new Boton("boton_ok",500,300,50,50);
	
	//Inicializamos el boton izq
	boton_izq=new Boton("boton_izq",150,300,50,50);
	
	//Inicializamos el boton dch
	boton_dch=new Boton("boton_dch",350,300,50,50);
	
	//Progreso de la carga
	var total=3;
	trozo=100/total;
	progreso=1;
	
	jugador.cara_img.onload = function() {
		jugador.cara_img_w=jugador.cara_img.width;
		jugador.cara_img_h=jugador.cara_img.height;
		jugador.cara_w=jugador.cara_img.width;
		jugador.cara_h=jugador.cara_img.height;
		jugador.cara_x=265-jugador.cara_w/2;
		jugador.cara_y=175-jugador.cara_h/2;	
		progreso+=trozo;
	}
	jugador.cuerpo_img[0].onload = function() {progreso+=trozo;}
	jugador.cuerpo_img[1].onload = function() {progreso+=trozo;}
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();	
}

function run(){
	animar();
	dibujar();
}

function animar(){	
}

function dibujar() {

	if(progreso<100){
		draw_progressbar();
	}else{
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
		
		dibujar_fondo();		
		dibujar_jugador();
		dibujar_botones();
		
		draw_fadein();
		draw_fadeout();
	}
}
function actualizar_cara(){
	
	var ca=jugador.cuerpo_activo;

	//Trozo arriba
	if(jugador.cara_y>=jugador.cuerpo_y[0]+jugador.lim_arr[ca])
		jugador.trozo_arriba=0;
	else
		jugador.trozo_arriba=jugador.cuerpo_y[0]+jugador.lim_arr[ca]-jugador.cara_y;
		
	jugador.img_y1=(jugador.trozo_arriba/(jugador.cara_h*jugador.escala))*jugador.cara_img_h;
	
	//Trozo abajo
	if(jugador.cara_y+jugador.cara_h*jugador.escala<=jugador.cuerpo_y[0]+jugador.lim_abj[ca])
		jugador.trozo_abajo=0;
	else
		jugador.trozo_abajo=(jugador.cara_y+jugador.cara_h*jugador.escala)-(jugador.cuerpo_y[0]+jugador.lim_abj[ca]);
		
	jugador.img_y2=jugador.cara_img_h-((jugador.trozo_abajo/(jugador.cara_h*jugador.escala))*jugador.cara_img_h);
	
	if(jugador.cara_y<jugador.cuerpo_y[0]+jugador.lim_arr[ca])
		jugador.lienzo_y=jugador.cuerpo_y[0]+jugador.lim_arr[ca];
	else
		jugador.lienzo_y=jugador.cara_y;
		
	//Trozo izquierda
	if(jugador.cara_x>=jugador.cuerpo_x[0]+jugador.lim_izq[ca])
		jugador.trozo_izquierda=0;
	else
		jugador.trozo_izquierda=jugador.cuerpo_x[0]+jugador.lim_izq[ca]-jugador.cara_x;
		
	jugador.img_x1=(jugador.trozo_izquierda/(jugador.cara_w*jugador.escala))*jugador.cara_img_w;
	
	//Trozo derecha
	if(jugador.cara_x+jugador.cara_w*jugador.escala<=jugador.cuerpo_x[0]+jugador.lim_dch[ca])
		jugador.trozo_derecha=0;
	else
		jugador.trozo_derecha=(jugador.cara_x+jugador.cara_w*jugador.escala)-(jugador.cuerpo_x[0]+jugador.lim_dch[ca]);
		
	jugador.img_x2=jugador.cara_img_w-((jugador.trozo_derecha/(jugador.cara_w*jugador.escala))*jugador.cara_img_w);
	
	if(jugador.cara_x<jugador.cuerpo_x[0]+jugador.lim_izq[ca])
		jugador.lienzo_x=jugador.cuerpo_x[0]+jugador.lim_izq[ca];
	else
		jugador.lienzo_x=jugador.cara_x;
		
	/*imprime_mensaje("escala: "+jugador.escala+
	" trozo_izquierda: "+(jugador.trozo_izquierda)+
	" trozo_derecha: "+(jugador.trozo_derecha)+
	" trozo_arriba: "+(jugador.trozo_arriba)+
	" trozo_abajo: "+(jugador.trozo_abajo)+
	" face_x: "+(jugador.cara_x-jugador.cuerpo_x[0])+" face_y: "+(jugador.cara_y-jugador.cuerpo_y[0])+" img_w: "+jugador.cara_img_w+" img_h: "+jugador.cara_img_h
	);*/
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_banda.style.display="block";
		document.formulario.texto_user.style.display="block";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_banda.style.display="none";
		document.formulario.texto_user.style.display="none";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function limitar_decimales(n,d){
	if(d>0){
		p=10;
		while(d>1){
			p*=10;
			d--;
		}
		n*=p;
		n=parseInt(Math.round(n));
		n/=p;
	}
	return n;
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}

function redireccionar(url){location.href=url;}